//
//  GetLocationMethodHandler.swift
//  bmap_flutter
//
//  Created by 刘建林 on 2021/7/20.
//
class GetLocationMethodHandler:NSObject, BMKLocationManagerDelegate, BMKLocationAuthDelegate {
    
    let locationManager = BMKLocationManager.init()
    let userLocation = BMKUserLocation.init()
    
    var start = false
    
    override init() {
        super.init()
        BMKLocationAuth.sharedInstance().checkPermision(withKey: "htDbhbma47fpxsPp9BGncvKEwX5mb9lF", authDelegate: self)
        locationManager.delegate = self
        locationManager.coordinateType = BMKLocationCoordinateType.GCJ02
        locationManager.distanceFilter = kCLDistanceFilterNone
        locationManager.desiredAccuracy = kCLLocationAccuracyHundredMeters
        locationManager.isNeedNewVersionReGeocode = true
    }
    
    func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        switch call.method {
        case "get-location":
            if(!start){
                Consts.mapView?.showsUserLocation = true
                Consts.mapView?.userTrackingMode = BMKUserTrackingModeHeading
                self.locationManager.startUpdatingLocation()
                start = true
            }
            
            Consts.currentKeyword = ""
            Consts.needSetCurrentLocation = true
        case "set-center":
            if let args = call.arguments as? Dictionary<String, Any>,
                let latitude = args["latitude"] as? Double,
                let longitude = args["longitude"] as? Double{
                Consts.getPoiWhenMapStatusChange = false
                Consts.mapView?.setCenter(CLLocationCoordinate2D(latitude: latitude, longitude: longitude), animated: true)
                }
        case "stop":
            locationManager.stopUpdatingLocation()
            start = false
        default:
            result(false)
        }
    }
    
    func bmkLocationManager(_ manager: BMKLocationManager, didUpdate location: BMKLocation?, orError error: Error?) {
        if(error == nil){
            userLocation.location = location?.location
            Consts.mapView?.updateLocationData(userLocation)
            
            if Consts.needSetCurrentLocation {
                let latLng = location?.location?.coordinate
                
                if latLng != nil{
                    Consts.mapView?.setCenter(latLng!, animated: true)
                    Consts.mapView?.zoomLevel = 17
                }
            }
        }
        
        Consts.needSetCurrentLocation = false
    }
    
    func bmkLocationManager(_ manager: BMKLocationManager, didFailWithError error: Error?) {
        NSLog("error")
    }
    
    func bmkLocationManagerDidChangeAuthorization(_ manager: BMKLocationManager) {
        
    }
    
    func bmkLocationManager(_ manager: BMKLocationManager, didUpdate heading: CLHeading?) {
        userLocation.heading = heading
        Consts.mapView?.updateLocationData(userLocation)
    }
}
